"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _promisePolyfill = _interopRequireDefault(require("promise-polyfill"));

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _MuiForm = _interopRequireWildcard(require("./MuiForm"));

var _utils = require("../utils/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MuiComponent = /*#__PURE__*/function (_React$Component) {
  _inherits(MuiComponent, _React$Component);

  var _super = _createSuper(MuiComponent);

  function MuiComponent() {
    var _this;

    _classCallCheck(this, MuiComponent);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isValid: true,
      value: _this.props.value,
      errorMessages: _this.props.errorMessages,
      validators: _this.props.validators
    });

    _defineProperty(_assertThisInitialized(_this), "getErrorMessage", function () {
      var errorMessages = _this.state.errorMessages;

      var type = _typeof(errorMessages);

      if (type === 'string') {
        return errorMessages;
      } else if (type === 'object') {
        if (_this.invalid.length > 0) {
          return errorMessages[_this.invalid[0]];
        }
      } // eslint-disable-next-line


      console.log('unknown errorMessages type', errorMessages);
      return true;
    });

    _defineProperty(_assertThisInitialized(_this), "instantValidate", true);

    _defineProperty(_assertThisInitialized(_this), "invalid", []);

    _defineProperty(_assertThisInitialized(_this), "configure", function () {
      _this.form.attachToForm(_assertThisInitialized(_this));

      _this.instantValidate = _this.form.instantValidate;
      _this.debounceTime = _this.form.debounceTime;
      _this.validateDebounced = (0, _utils.debounce)(_this.validate, _this.debounceTime);
    });

    _defineProperty(_assertThisInitialized(_this), "validate", function (value) {
      var includeRequired = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var dryRun = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      var validations = _promisePolyfill["default"].all(_this.state.validators.map(function (validator) {
        return _MuiForm["default"].getValidator(validator, value, includeRequired);
      }));

      return validations.then(function (results) {
        _this.invalid = [];
        var valid = true;
        results.forEach(function (result, key) {
          if (!result) {
            valid = false;

            _this.invalid.push(key);
          }
        });

        if (!dryRun) {
          _this.setState({
            isValid: valid
          }, function () {
            _this.props.validatorListener(_this.state.isValid);
          });
        }

        return valid;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "isValid", function () {
      return _this.state.isValid;
    });

    _defineProperty(_assertThisInitialized(_this), "makeInvalid", function () {
      _this.setState({
        isValid: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "makeValid", function () {
      _this.setState({
        isValid: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderComponent", function (form) {
      if (!_this.form) {
        _this.form = form;
      }

      return _this.renderMuiComponent();
    });

    return _this;
  }

  _createClass(MuiComponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.configure();
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state !== nextState || this.props !== nextProps;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.instantValidate && this.props.value !== prevState.value) {
        this.validateDebounced(this.props.value, this.props.withRequiredValidator);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.form.detachFromForm(this);
      this.validateDebounced.cancel();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/_react["default"].createElement(_MuiForm.FormContext.Consumer, null, function (_ref) {
        var form = _ref.form;
        return /*#__PURE__*/_react["default"].createElement("div", _this2.props.containerProps, _this2.renderComponent(form));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.validators && nextProps.errorMessages && (prevState.validators !== nextProps.validators || prevState.errorMessages !== nextProps.errorMessages)) {
        return {
          value: nextProps.value,
          validators: nextProps.validators,
          errorMessages: nextProps.errorMessages
        };
      }

      return {
        value: nextProps.value
      };
    }
  }]);

  return MuiComponent;
}(_react["default"].Component);

MuiComponent.propTypes = {
  errorMessages: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].string]),
  validators: _propTypes["default"].array,
  value: _propTypes["default"].any,
  validatorListener: _propTypes["default"].func,
  withRequiredValidator: _propTypes["default"].bool,
  containerProps: _propTypes["default"].object
};
MuiComponent.defaultProps = {
  errorMessages: 'error',
  validators: [],
  validatorListener: function validatorListener() {}
};
(0, _reactLifecyclesCompat.polyfill)(MuiComponent);
var _default = MuiComponent;
exports["default"] = _default;