"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.FormContext = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _promisePolyfill = _interopRequireDefault(require("promise-polyfill"));

var _reactCreateThemeContext = _interopRequireDefault(require("react-create-theme-context"));

var _MuiRules = _interopRequireDefault(require("./MuiRules"));

var _excluded = ["onSubmit", "instantValidate", "onError", "debounceTime", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FormContext = (0, _reactCreateThemeContext["default"])('form');
exports.FormContext = FormContext;

var MuiForm = /*#__PURE__*/function (_React$Component) {
  _inherits(MuiForm, _React$Component);

  var _super = _createSuper(MuiForm);

  function MuiForm() {
    var _this;

    _classCallCheck(this, MuiForm);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "getFormHelpers", function () {
      return {
        form: {
          attachToForm: _this.attachToForm,
          detachFromForm: _this.detachFromForm,
          instantValidate: _this.instantValidate,
          debounceTime: _this.debounceTime
        }
      };
    });

    _defineProperty(_assertThisInitialized(_this), "instantValidate", _this.props.instantValidate !== undefined ? _this.props.instantValidate : true);

    _defineProperty(_assertThisInitialized(_this), "debounceTime", _this.props.debounceTime);

    _defineProperty(_assertThisInitialized(_this), "childs", []);

    _defineProperty(_assertThisInitialized(_this), "errors", []);

    _defineProperty(_assertThisInitialized(_this), "attachToForm", function (component) {
      if (_this.childs.indexOf(component) === -1) {
        _this.childs.push(component);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "detachFromForm", function (component) {
      var componentPos = _this.childs.indexOf(component);

      if (componentPos !== -1) {
        _this.childs = _this.childs.slice(0, componentPos).concat(_this.childs.slice(componentPos + 1));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "submit", function (event) {
      if (event) {
        event.preventDefault();
        event.persist();
      }

      _this.errors = [];

      _this.walk(_this.childs).then(function (result) {
        if (_this.errors.length) {
          _this.props.onError(_this.errors);
        }

        if (result) {
          _this.props.onSubmit(event);
        }

        return result;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "walk", function (children, dryRun) {
      var self = _assertThisInitialized(_this);

      return new _promisePolyfill["default"](function (resolve) {
        var result = true;

        if (Array.isArray(children)) {
          _promisePolyfill["default"].all(children.map(function (input) {
            return self.checkInput(input, dryRun);
          })).then(function (data) {
            data.forEach(function (item) {
              if (!item) {
                result = false;
              }
            });
            resolve(result);
          });
        } else {
          self.walk([children], dryRun).then(function (result) {
            return resolve(result);
          });
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "checkInput", function (input, dryRun) {
      return new _promisePolyfill["default"](function (resolve) {
        var result = true;
        var validators = input.props.validators;

        if (validators) {
          _this.validate(input, true, dryRun).then(function (data) {
            if (!data) {
              result = false;
            }

            resolve(result);
          });
        } else {
          resolve(result);
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "validate", function (input, includeRequired, dryRun) {
      return new _promisePolyfill["default"](function (resolve) {
        var value = input.props.value;
        input.validate(value, includeRequired, dryRun).then(function (valid) {
          if (!valid) {
            _this.errors.push(input);
          }

          resolve(valid);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "find", function (collection, fn) {
      for (var i = 0, l = collection.length; i < l; i++) {
        var item = collection[i];

        if (fn(item)) {
          return item;
        }
      }

      return null;
    });

    _defineProperty(_assertThisInitialized(_this), "resetValidations", function () {
      _this.childs.forEach(function (child) {
        child.validateDebounced.cancel();
        child.setState({
          isValid: true
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "isFormValid", function () {
      var dryRun = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      return _this.walk(_this.childs, dryRun);
    });

    return _this;
  }

  _createClass(MuiForm, [{
    key: "render",
    value: function render() {
      // eslint-disable-next-line
      var _this$props = this.props,
          onSubmit = _this$props.onSubmit,
          instantValidate = _this$props.instantValidate,
          onError = _this$props.onError,
          debounceTime = _this$props.debounceTime,
          children = _this$props.children,
          rest = _objectWithoutProperties(_this$props, _excluded);

      return /*#__PURE__*/_react["default"].createElement(FormContext.Provider, {
        value: this.getFormHelpers()
      }, /*#__PURE__*/_react["default"].createElement("form", _extends({}, rest, {
        onSubmit: this.submit
      }), children));
    }
  }]);

  return MuiForm;
}(_react["default"].Component);

_defineProperty(MuiForm, "getValidator", function (validator, value, includeRequired) {
  var result = true;
  var name = validator;

  if (name !== 'required' || includeRequired) {
    var extra;
    var splitIdx = validator.indexOf(':');

    if (splitIdx !== -1) {
      name = validator.substring(0, splitIdx);
      extra = validator.substring(splitIdx + 1);
    }

    result = _MuiRules["default"][name](value, extra);
  }

  return result;
});

MuiForm.addValidationRule = function (name, callback) {
  _MuiRules["default"][name] = callback;
};

MuiForm.getValidationRule = function (name) {
  return _MuiRules["default"][name];
};

MuiForm.hasValidationRule = function (name) {
  return _MuiRules["default"][name] && typeof _MuiRules["default"][name] === 'function';
};

MuiForm.removeValidationRule = function (name) {
  delete _MuiRules["default"][name];
};

MuiForm.propTypes = {
  onSubmit: _propTypes["default"].func.isRequired,
  instantValidate: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  onError: _propTypes["default"].func,
  debounceTime: _propTypes["default"].number
};
MuiForm.defaultProps = {
  onError: function onError() {},
  debounceTime: 0
};
var _default = MuiForm;
exports["default"] = _default;